#!/usr/bin/env python
#
# This script checks every single variable available in the CDS download form
# for all existing datasets within, except for those that does not have any
# kind of download form but are available through the CDS (i.e. era5-complete)
#
# AUTHOR: Barcelona Supercomputing Center-Centro Nacional de Supercomputacion
#         Earth Sciences Department
#         I. CERNICHARO: ivan.cernicharo@bsc.es
#

import requests
import json
import datetime

cds_url = 'https://cds.climate.copernicus.eu/api/v2.ui/resources'
response1 = requests.get(cds_url).json()

response_lvl1 = []
for item in response1:
    response_lvl1.append(cds_url+'/'+str(item))

dict_datasets = {}
for i,element in enumerate(response_lvl1):
    print
    print("---------------------------------------------------------------------")
    print
    print("Requesting")
    print("  >Index %s %s" %(i,element))
    print
    ap = requests.get(element).json()
    #dict_d = {}
    if "form" in ap and ap["form"] != None:
        counter = 0
        print
        print(">Dataset Name:",ap["name"])
        dict_var = {}
        for item in ap["form"]:
            if "dict" in str(type(item)):
                if item["label"] in ["Variable"]:
                    for e in item.keys():
                        if e == "details":
                            for op in item[e].keys():
                                if "list" in str(type(item[e][op])):
                                    if item["label"] == "Variable" and op == "values": 
                                        dict_var.update({"Variable":item[e][op]})
                                    elif item["label"] == "Product type" and op == "values":
                                        dict_var.update({"Product type":item[e][op]})
                                    if op == "groups" and "groups" in item[e].keys():
                                        more_vars = {}
                                        for aj in item[e][op]:
                                            more_vars.update({aj["label"]:aj["values"]})
                                        dict_var.update({"Variable":more_vars})
            counter += 1
        dict_datasets.update({ap["name"]:dict_var})
    else:
        dict_datasets.update({ap["name"]:"No readeable form"})
    
json_name = "cds_variables_"+str(datetime.datetime.now().date().isoformat().replace("-",""))+".json"
print
print("Saving as %s" %json_name)
print
with open(json_name,"w") as fp:
    json.dump(dict_datasets,fp,indent=4,sort_keys=True)
fp.close()
print
print("FINISHED")
print